#!/bin/bash
set -e

CPU_CORES=$(nproc --all)

build() {
    # $1: the directory to build
    echo "Building $1..."
    (cd "$1" && make -j$CPU_CORES)
    echo
}

# build Iris
build iris

# prepare lib directory
if ! test -d coqlibdir; then
    mkdir coqlibdir
    ln -s "$PWD"/iris/theories coqlibdir/iris
fi
export COQPATH="$PWD/coqlibdir"

# build the rest of them
build fairis
build ora
build igps
build cfml
build chl
build lambda-rust
