From iris.bi Require Import bi.
From igps Require Import infrastructure.

(* These lemmas probably belong somewhere higher. *)

Section lemmas.

Context {PROP : bi}.

Lemma Forall_nth : forall {A} (P : A -> Prop) l i d, i < length l -> Forall P l ->
  P (nth i l d).
Proof.
  intros; eapply Forall_lookup_1; eauto.
  destruct (nth_lookup_or_length l i d); [done | omega].
Qed.

Lemma big_sepL_seq {A} (P : nat -> PROP) (l : list A):
  ([∗ list] i↦_ ∈ l, P i) ⊣⊢ ([∗ list] i ∈ seq 0 (length l), P i).
Proof.
  induction l using rev_ind; first done.
  rewrite app_length /= Nat.add_1_r seq_S !big_sepL_app /=.
  by rewrite IHl Nat.add_0_r.
Qed.

Lemma big_sepL_nth {A} (P : nat -> A -> PROP) l d:
  ([∗ list] i↦x ∈ l, P i x) ⊣⊢ ([∗ list] i ∈ seq 0 (length l), P i (nth i l d)).
Proof.
  rewrite -big_sepL_seq.
  apply big_sepL_proper; intros.
  erewrite nth_lookup_Some; eauto.
Qed.

Lemma nth_replicate {A} i n (x : A): nth i (replicate n x) x = x.
Proof.
  destruct (decide (i < length (replicate n x))%nat); last by apply nth_overflow; omega.
  by apply Forall_nth, Forall_replicate.
Qed.

Lemma big_sepL_replicate {A} (P : nat -> A -> PROP) x n: 
  ([∗ list] i↦x ∈ replicate n x, P i x) ⊣⊢ ([∗ list] i ∈ seq 0 n, P i x).
Proof.
  rewrite big_sepL_nth replicate_length.
  apply big_sepL_proper; intros.
  by erewrite nth_replicate.
Qed.    

End lemmas.
