From iris.base_logic Require Import upred derived.
From iris.proofmode Require Import tactics.
From igps Require Export weakestpre notation wp_tactics_vProp lifting_vProp.
Import uPred.

(* Definition repeat (e: base.expr): base.expr := *)
Notation repeat e :=
  ((rec: "f" <> :=
     let: "v" := e in
      if: "v" = #(lit_of_bool false)
      then "f" #()
      else "v") #())%E.

Lemma wp_repeat `{ghosts.foundationG Σ} E e Φ `{He : Closed nil e} :
  WP e @ E
    {{ v, ∃ z, ⌜v = LitV $ LitInt z⌝
          ∧ if bool_decide (z = 0)
            then ▷ ▷ (WP (repeat e) @ E {{v, Φ v }}) else ▷ ▷ Φ #z }}
     ⊢ WP (repeat e) @ E {{ Φ }}.
Proof.
  iIntros "H".
  wp_rec.
  wp_bind e. iApply wp_mono; [|iExact "H"].
  iIntros (v) "H". iDestruct "H" as (l) "(% & R)".
  rewrite /= H0 /= {H0}.
  wp_lam.
  case HD: (bool_decide _);
  wp_op; rewrite HD; [by wp_if_true|by wp_if_false].
Qed.
