From iris.program_logic Require Export weakestpre.
From iris.proofmode Require Import tactics.
From igps Require Import persistor fractor notation weakestpre ro na invariants proofmode ghosts.
Import uPred lang.base.

Section test.
  Context `{fG : foundationG Σ}
          `{persG : persistorG Σ}
          {cG : cancelable_invariants.cinvG Σ}.

Lemma test N l v V (HN: ↑physN ∪ ↑fracN ## namespaces.nclose N):
  {{{ ⎡PSCtx⎤ ∗ inv N (own_loc_ro l v V) ∗ monPred_in V }}} [ #l]_na {{{ RET #v; emp }}}.
Proof.
  intros; iIntros "(#kI & #inv & in) Hpost".
  iMod (inv_open with "inv") as "[oL Hclose]"; first done.
  iMod (timeless with "oL") as "oL".
  { admit. }
  iPoseProof (all_now with "oL") as "oL".
  iPoseProof (ro_split with "[$in $oL]") as "[oL oL']".
  iDestruct "oL'" as (q) "oL'".
  apply disjoint_union_l in HN as [].
  iApply (na_read_frac with "[$]").
  { by apply namespaces.ndisj_subseteq_difference. }
  { etrans; first apply namespaces.nclose_subseteq.
    by apply namespaces.ndisj_subseteq_difference. }
  iNext; iIntros (?) "[% oL']"; subst.
  iMod ("Hclose" with "[oL]"); first by iApply objective_objectively.
  iApply "Hpost"; auto.
Admitted.