From iris.program_logic Require Import weakestpre.
From iris.base_logic Require Import lib.invariants lib.cancelable_invariants.

From igps Require Import viewpred proofmode weakestpre fractor.
From igps Require Export notation bigop.
From igps.base Require Export ghosts fork.

Lemma wp_fork `{fG : foundationG Σ} E e Φ :
  ↑physN ⊆ E →
  ⎡PSCtx⎤ ∗ ▷ Φ #() ∗ ▷ WP e {{ _, True }} ⊢ WP base.Fork e @ E {{ Φ }}.
Proof.
  rewrite WP_Def.wp_eq /WP_Def.wp_def.
  iStartProof (uPred _); iIntros (??) "/=".
  iIntros "(? & ? & ?)" (???) "?".
  iApply program_logic.weakestpre.wp_mask_mono; first done.
  iApply f_fork; iFrame.
  iSplitL "".
  - iNext; iIntros (??) "?"; iFrame.
    iPureIntro; etransitivity; eauto.
  - iNext; iIntros (? v' ?) "? Ht H".
    iSpecialize ("H" $! _ with "[%] Ht"); [by etrans|].
    iApply (program_logic.weakestpre.wp_mono with "H"); auto.
Qed.
