From iris.base_logic Require Import iprop wsat.
From iris.base_logic Require invariants.
From iris.proofmode Require Import tactics.
From igps Require Import ghosts viewpred ro.

Section Invariants.
  Context {Σ : gFunctors} `{fG : !foundationG Σ} `{W : invG.invG Σ}.
  Definition inv N (P : vProp Σ) : vProp Σ := ⎡invariants.inv N (∀ V, monPred_at P V)⎤%I.

  Lemma inv_alloc N (E : coPset) (P : vProp Σ) : ▷ (<obj> P) -∗ |={E}=> inv N P.
  Proof.
    iIntros "H". rewrite monPred_objectively_unfold /= -embed_later.
    by iMod (invariants.inv_alloc with "H") as "$".
  Qed.

  Lemma inv_alloc_open N (E : coPset) (P : vProp Σ) :
    ↑N ⊆ E → (|={E,E ∖ ↑N}=> inv N P ∗ (▷ (<obj> P) ={E ∖ ↑N,E}=∗ True))%I.
  Proof.
    rewrite monPred_objectively_unfold /= -embed_later.
    iIntros (?). iMod (invariants.inv_alloc_open) as "[$ Close]"; [done|].
    iIntros "!> H". by iMod ("Close" with "H").
  Qed.

 Lemma inv_open (E : coPset) N (P : vProp Σ) :
   ↑N ⊆ E → inv N P -∗ |={E,E ∖ ↑N}=> ▷ (<obj> P) ∗ (▷ (<obj> P) ={E ∖ ↑N,E}=∗ True).
 Proof.
   iIntros (?) "H". rewrite monPred_objectively_unfold /= -embed_later.
   iMod (invariants.inv_open with "H") as "[$ Close]"; [done|].
   iIntros "!> H". by iMod ("Close" with "H").
 Qed.

 (* TODO : this should be removed and replaced with the general iAlways
    tactic. *)
 (* FIXME: It should not be necessary to explicitly call the bi_emp_valid
    coercion. *)
 Lemma objectively_entails (P Q : vProp Σ) : (P -∗ Q) -> bi_emp_valid (<obj> (P -∗ Q))%I.
 Proof. iStartProof (iProp _). iIntros (H V ???). rewrite H. auto. Qed.
End Invariants.
