From iris.program_logic Require Import ectx_language ectxi_language language.
From stdpp Require Export strings gmap.
From iris.algebra Require Import ofe.

From igps Require Export machine.
From igps.lang Require base ra_lang.


Definition ctx_lift (K : base.expr -> base.expr) : ra_lang.expr -> ra_lang.expr := λ '(e,V), (K e, V).

Ltac dest_expr :=
  match reverse goal with
  | [ e : expr _ |- _] => let V' := fresh "V" in destruct e as [e V']
  | [ e : expr ra_lang.ra_lang |- _] => let V' := fresh "V" in destruct e as [e V']
  | [ e : ra_lang.expr |- _] => let V' := fresh "V" in destruct e as [e V']
  | [ e : base.expr * View |- _] => let V' := fresh "V" in destruct e as [e V']
  end.
Ltac dest_exprs := repeat dest_expr.

Lemma fill_view K (e : base.expr) V:
  fill (Λ:=ra_lang.ra_ectxi_lang) K (e,V) = (base.fill K e, V).
Proof.
  rewrite /ectx_language.fill /= /ectxi_language.fill /=.
  elim: K e V => [//|/= k K IHK] e V.
  by rewrite IHK.
Qed.

Lemma prim_step_view_mono e V1 σ1 e2 V2 σ2 efs : ectx_language.prim_step (Λ:=ra_lang.ra_ectx_lang) (e, V1) σ1 (e2, V2) σ2 efs → V1 ⊑ V2.
Proof.
  destruct 1. destruct e1', e2'.
  cbn in *.
  rewrite !fill_view in H, H0.
  inversion H; inversion H0; subst.
  exact: ra_lang.head_step_mono.
Qed.

Delimit Scope binder_scope with bind.
Bind Scope binder_scope with base.binder.
Infix ":b:" := base.cons_binder (at level 60, right associativity).

Export ra_lang.
