From iris.program_logic Require Import ectx_language ectxi_language language.
From stdpp Require Export strings gmap.
From iris.algebra Require Import ofe.

From igps Require Export machine.
From igps.lang Require base ra_lang.

Import base.

Definition head_step e1 σ1 e2 σ2 efs :=
  ra_lang.head_step (e1, fst σ1) (snd σ1) (e2, fst σ2) (snd σ2) (map (fun e => (e, fst σ2)) efs).

(** Language *)
Lemma surface_ectxi_language_mixin :
  EctxiLanguageMixin base.of_val base.to_val base.fill_item head_step.
Proof.
  unfold head_step.
  split;
  eauto using to_of_val, of_to_val,
  val_stuck, fill_item_val, fill_item_no_val_inj,
  head_ctx_step_val.
  - intros. destruct σ1 as [V1 σ1]. destruct σ2 as [V2 σ2]. cbn in H.
    cut (ra_lang.to_val (e1, V1) = None).
    + cbn. by rewrite fmap_None.
    + refine (ectxi_language.mixin_val_stuck _ _ _ _ _ _ _ _ _ _ H).
      exact ra_lang.ra_ectxi_language_mixin. (* ???? *)
  - intros.
    cut (Inj eq eq (ra_lang.fill_item Ki)).
    + unfold ra_lang.fill_item.
      intros ? e1 e2 Eq.
      set x := (H (e1, empty) (e2, empty)).
      move: x. cbn. rewrite Eq. by move => /(_ eq_refl) [->].
    + apply: (ectxi_language.mixin_fill_item_inj).
      exact ra_lang.ra_ectxi_language_mixin. (* ???? *)
  - intros.
    cut (is_Some (ra_lang.to_val (e, σ1.1))).
    + cbn. by rewrite fmap_is_Some.
    + apply: (ectxi_language.mixin_head_ctx_step_val).
      * exact ra_lang.ra_ectxi_language_mixin. (* ???? *)
      * eassumption.
Qed.

Canonical Structure surface_ectxi_lang :=
  EctxiLanguage surface_ectxi_language_mixin.

Canonical Structure surface_ectx_lang := EctxLanguageOfEctxi surface_ectxi_lang.
Canonical Structure surface_lang := LanguageOfEctx surface_ectx_lang.
