From iris.proofmode Require Export tactics.
From igps Require Import viewpred.

Global Instance Frame_vPred Σ p (P : vProp Σ) :
  Frame p (monPred_at P V) (monPred_at P V') ⌜V ⊑ V'⌝ | 30.
Proof. intros. unfold Frame. iIntros "[? %]". rewrite H. by destruct p => /=. Qed.
Hint Extern 10 (IsBiIndexRel _ _) => unfold IsBiIndexRel; solve_jsl
            : typeclass_instances.

Ltac iViewCnt fn :=
      let V := fresh "V" in
              let HV := fresh "HV" in
              iIntros (V HV); cbn in HV;
              fn V HV.
Ltac iView := iViewCnt ltac:(fun _ _ => idtac).
Ltac iViewUp :=
  iViewCnt ltac:(fun V HV =>
              let X := fresh "X" in
              match type of HV with
              | ?V_old ⊑ V => setoid_rewrite HV; try (clear V_old HV; rename V into V_old)
              end).
