From iris.program_logic Require Import weakestpre.
From iris.base_logic Require Import lib.cancelable_invariants.
From igps Require Import proofmode na weakestpre fractor.

Section RO.
 Context {Σ : gFunctors} `{fG : foundationG Σ} `{cG : cinvG Σ}.

 Definition own_loc_ro l v V : vProp Σ := ⎡∃q, (l ↦{q} v) V⎤%I.

 Lemma ro_split l v V: monPred_in V ∗ own_loc_ro l v V -∗ own_loc_ro l v V ∗ ∃q, l ↦{q} v.
 Proof.
   iStartProof (uPred _).
   iIntros (i) "[% oL]"; iDestruct "oL" as (q) "oL".
   iPoseProof (na_frac_split_2 with "oL") as "[oL1 oL2]".
   iSplitL "oL1"; first by iExists (q/2)%Qp.
   iDestruct "oL2" as (V') "[??]"; eauto.
 Qed.

End RO.
